!     COMMON BLOCK TABCOM CONTAINS QUANTITIES PRECOMPUTED IN SUBROUTINE
!     TABLE FOR USE IN THE LONGWAVE RADIATION PROGRAM:
!          EM1     =  E1 FUNCTION, EVALUATED OVER THE 0-560 AND
!                     1200-2200 CM-1 INTERVALS
!          EM1WDE  =  E1 FUNCTION, EVALUATED OVER THE 160-560 CM-1
!                     INTERVAL
!          TABLE1  =  E2 FUNCTION, EVALUATED OVER THE 0-560 AND
!                     1200-2200 CM-1 INTERVALS
!          TABLE2  =  TEMPERATURE DERIVATIVE OF TABLE1
!          TABLE3  =  MASS DERIVATIVE OF TABLE1
!          EM3     =  E3 FUNCTION, EVALUATED OVER THE 0-560 AND
!                     1200-2200 CM-1 INTERVALS
!          SOURCE  =  PLANCK FUNCTION, EVALUATED AT SPECIFIED TEMPS. FOR
!                     BANDS USED IN CTS CALCULATIONS
!          DSRCE   =  TEMPERATURE DERIVATIVE OF SOURCE
!          IND     =  INDEX, WITH VALUE IND(I)=I. USED IN FST88
!          INDX2   =  INDEX VALUES USED IN OBTAINING "LOWER TRIANGLE"
!                     ELEMENTS OF AVEPHI,ETC.,IN FST88
!          KMAXV   =  INDEX VALUES USED IN OBTAINING "UPPER TRIANGLE"
!                     ELEMENTS OF AVEPHI,ETC.,IN FST88
!          KMAXVM  =  KMAXV(L),USED FOR DO LOOP INDICES

    COMMON / TABCOM / IND(IMAX),INDX2(LP1V),KMAXV(LP1), &
    KMAXVM
    COMMON/TABCOM/EM1(28,180),EM1WDE(28,180),TABLE1(28,180), &
    TABLE2(28,180),TABLE3(28,180),EM3(28,180),SOURCE(28,NBLY), &
    DSRCE(28,NBLY)
