    SUBROUTINE MPI_LAST
!$$$  SUBPROGRAM DOCUMENTATION BLOCK
!                .      .    .
!   SUBROUTINE:  MPI_LAST    SHUTS DOWN MPI
!   PRGRMMR: TUCCILLO        ORG:  IBM       DATE: 00-01-20

! ABSTRACT:   SHUTS DOWN MPI

! PROGRAM HISTORY LOG:
!   00-01-20  TUCCILLO - ORIGINATOR

! USAGE:  CALL MPI_LAST

!   INPUT ARGUMENT LIST:

!   OUTPUT ARGUMENT LIST:

!   INPUT FILES:  NONE

!   OUTPUT FILES:  NONE

!   SUBPROGRAMS CALLED:
!     UNIQUE:
!            MPI_FINALIZE

!   EXIT STATES:
!     COND =   0 - NORMAL EXIT

! ATTRIBUTES:
!   LANGUAGE: FORTRAN 90
!   MACHINE : IBM SP

!$$$

    call MPI_FINALIZE(ierr)
    END SUBROUTINE MPI_LAST
