!-------------------------------------------------------------
!***  SET PRIMARY GRID DIMENSIONS AND PRESSURE OUTPUT LEVELS
      INTEGER,PARAMETER:: IM=241,JM=433,LM=50,LSM=39
!-------------------------------------------------------------
!***  SET THE NUMBER OF PEs IN THE I-DIRECTION AND J-DIRECTION
      INTEGER,PARAMETER:: INPES=12,JNPES=30
!-------------------------------------------------------------

      INTEGER,PARAMETER:: IGSTL=-5,IGSTR=5
      INTEGER,PARAMETER:: JGSTL=-5,JGSTR=5
      INTEGER,PARAMETER:: ITAIL=IM-(INPES*(IM/INPES))
      INTEGER,PARAMETER:: JTAIL=JM-(JNPES*(JM/JNPES))

      INTEGER,PARAMETER:: IDIM1=IGSTL,IDIM2=IM/INPES+IGSTR+1
      INTEGER,PARAMETER:: JDIM1=JGSTL,JDIM2=JM/JNPES+JGSTR+1

!-------------------------------------------------------------
